<?php

/* ************************************************* *\
|* ================================================= *|
|* =       Copyright (c) 2012 Jacob Pollack.       = *|
|* ================================================= *|
|* = THIS SOFTWARE IS PRIVATE AND CANNOT BE FOUND  = *|
|* = ON THE PUBLIC DOMAIN. ANY DISTRIBUTION OR USE = *|
|* = OF THIS SOFTWARE WITHOUT THE EXPLICIT         = *|
|* = PERMISSION OF THE AUTHOR WILL RESULT IN LEGAL = *|
|* = ACTION BEING TAKEN.                           = *|
|* =                                               = *|
|* = THIS SOFTWARE IS CREATED FOR EDUCATIONAL      = *|
|* = PURPOSES ONLY. CHANGES OF ANY SORT MUST BE    = *|
|* = SUBMITTED TO THE RESPOSITORY ACCORDINGLY.     = *|
|* ================================================= *|
|* = @author    Jacob Pollack                      = *|
|* = @email     jacobpollack@jamach.com            = *|
|* = @date      05/08/2012 (DD/MM/YYYY)            = *|
|* =                                               = *|
|* = @contributors  none                           = *|
|* ================================================= *|
\*************************************************** */

/**
 * This is the casters file. Has a bunch of methods that
 * cast between different types.
 * 
 * @name    Casters
 * @author  Jacob Pollack
 */

/**
 * Casts an array to an object. Supports multi-dimensional
 * arrays too.
 * 
 * @param   array   $array  An array passed by reference.
 * 
 * @return  object
 * @return  boolean
 */
function array_to_object(array &$array)
{
    if (sizeof($array) > 0)
    {
        $object = new stdClass();

        foreach ($array as $key => $value)
        {
            if (empty($key) == false)
            {
                if (is_array($value) == true)
                {
                    $object->$key = array_to_object($value);
                }
                else
                {
                    $object->$key = $value;
                }
            }
        }

        // Cleans up.
        delete($array);

        return $object;
    }
    
    return false;
}

/**
 * Casts an array to an object. Supports multi-dimensional
 * arrays too. Caches the returned object.
 * 
 * @param   string  $name   The name of the cached entry.
 * @param   array   $array  An array passed by reference.
 */
function array_to_object_cache($name, array &$array)
{
    global $quasar;
    
    if ($quasar->object->cachehandler->file_exists($name) == false)
    {
        // Casts the array to an object.
        $object = array_to_object($array);
        
        // Stores in the cache.
        $quasar->object->cachehandler->file_store($name, $object);
        
        // Returns the raw object.
        return $object;
    }
    else
    {
        // Returns the cached object.
        return $quasar->object->cachehandler->file_fetch($name);
    }
}

?>