<?php

/* ************************************************* *\
|* ================================================= *|
|* =       Copyright (c) 2012 Jacob Pollack.       = *|
|* ================================================= *|
|* = THIS SOFTWARE IS PRIVATE AND CANNOT BE FOUND  = *|
|* = ON THE PUBLIC DOMAIN. ANY DISTRIBUTION OR USE = *|
|* = OF THIS SOFTWARE WITHOUT THE EXPLICIT         = *|
|* = PERMISSION OF THE AUTHOR WILL RESULT IN LEGAL = *|
|* = ACTION BEING TAKEN.                           = *|
|* =                                               = *|
|* = THIS SOFTWARE IS CREATED FOR EDUCATIONAL      = *|
|* = PURPOSES ONLY. CHANGES OF ANY SORT MUST BE    = *|
|* = SUBMITTED TO THE RESPOSITORY ACCORDINGLY.     = *|
|* ================================================= *|
|* = @author    Jacob Pollack                      = *|
|* = @email     jacobpollack@jamach.com            = *|
|* = @date      05/08/2012 (DD/MM/YYYY)            = *|
|* =                                               = *|
|* = @contributors  none                           = *|
|* ================================================= *|
\*************************************************** */

/**
 * The abstract class used to outline the skeleton for
 * all of the modules.
 * 
 * @name    Module
 * @author  Jacob Pollack
 */

abstract class module
{
    /**
     * Order in which to execute this module in comparison
     * to the other module(s).
     * 
     * @var integer
     */
    protected $order = -1;
    
    /**
     * Empty constructor.
     * 
     * @return  void
     */
    final public function __construct() { }
    
    /**
     * Code block to be executed on the invoke of the module.
     * 
     * @return  void
     */
    abstract public function load();
    
    /**
     * Determines whether to invoke the module.
     * 
     * @return  boolean
     */
    public function validate()
    {
        return false;
    }
    
    /**
     * Gets the order number of the module.
     * 
     * @return  integer
     */
    final public function get_order()
    {
        return $this->order;
    }
    
    /**
     * Empty destructor.
     * 
     * @return  void
     */
    final public function __destruct() { }
}

?>